Option Strict On
Imports System.Management
Imports System.Management.Instrumentation

<Assembly: Instrumented("root\Orders")> 

<System.ComponentModel.RunInstaller(True)> _
Public Class SalesInstaller
    Inherits DefaultManagementProjectInstaller

End Class

Namespace Sales
    <InstrumentationClass(InstrumentationType.Instance), Serializable()> _
    Public Class Order
        ' This is a simple object to demonstrate what can be sent
        Private m_strCustomerID As String
        Private m_intOrderID As Integer
        Private m_objOrderDetails As New OrderDetails()

        Sub New()
            ' This informs WMI that the object instance exits
            System.Management.Instrumentation.Instrumentation.Publish(Me)
        End Sub
        Property CustomerID() As String
            Get
                Return m_strCustomerID
            End Get
            Set(ByVal Value As String)
                m_strCustomerID = Value
            End Set
        End Property
        Property OrderID() As Integer
            Get
                Return m_intOrderID
            End Get
            Set(ByVal Value As Integer)
                m_intOrderID = Value
            End Set
        End Property

        Property OrderDetails() As OrderDetails
            Get
                Return m_objOrderDetails
            End Get
            Set(ByVal Value As OrderDetails)
                m_objOrderDetails = Value
            End Set
        End Property
        Sub Save()
            ' This method will save the record
            Dim objOrdersCOMPlus As New Sales.COMPlus.OrderUpdate()
            objOrdersCOMPlus.Update(Me)
        End Sub
    End Class

    <InstrumentationClass(InstrumentationType.Instance), Serializable()> _
    Public Class OrderDetails
        Inherits System.Collections.CollectionBase

        Sub New()
            ' This informs WMI that the object instance exits
            System.Management.Instrumentation.Instrumentation.Publish(Me)
        End Sub


        ' This class implements a strongly typed custom collection
        Public Function Add(ByVal lineItem As LineItem) As Integer
            Dim intIndex As Integer = MyBase.List.Add(lineItem)

            System.Management.Instrumentation.Instrumentation.Publish(Me)
            Return intIndex
        End Function
        Public Function Add() As LineItem
            ' No item supplied so will create a new one
            Return Me.Item(Me.Add(New LineItem()))
        End Function
        Public Sub Remove(ByVal index As Integer)
            ' Check to see if there is a widget at the supplied index.
            If index > Count - 1 Or index < 0 Then
                ' If no widget exists, a messagebox is shown and the operation is 
                ' cancelled.
                Throw New Exception("Index not valid!")
            Else
                ' Invokes the RemoveAt method of the List object.
                List.RemoveAt(index)
            End If
        End Sub

        <IgnoreMember()> _
        Default Public ReadOnly Property Item(ByVal index As Integer) As LineItem
            Get
                Return CType(List.Item(index), LineItem)
            End Get
        End Property

        Shadows ReadOnly Property Count() As Integer
            Get
                Return MyBase.List.Count
            End Get
        End Property
    End Class

    <InstrumentationClass(InstrumentationType.Instance), Serializable()> _
    Public Class LineItem
        Private m_intProductID As Integer
        Private m_dblUnitPrice As Double
        Private m_intQuantity As Integer
        Private m_dblDiscount As Double

        Sub New()
            ' This informs WMI that the object instance exits
            System.Management.Instrumentation.Instrumentation.Publish(Me)
        End Sub

        Property ProductID() As Integer
            Get
                Return m_intProductID
            End Get
            Set(ByVal Value As Integer)
                m_intProductID = Value
            End Set
        End Property
        Property UnitPrice() As Double
            Get
                Return m_dblUnitPrice
            End Get
            Set(ByVal Value As Double)
                m_dblUnitPrice = Value
            End Set
        End Property
        Property Quantity() As Integer
            Get
                Return m_intQuantity
            End Get
            Set(ByVal Value As Integer)
                m_intQuantity = Value
            End Set
        End Property
        Property Discount() As Double
            Get
                Return m_dblDiscount
            End Get
            Set(ByVal Value As Double)
                m_dblDiscount = Value
            End Set
        End Property
    End Class
End Namespace
