Option Strict On
Imports System.Management


Public Class ReadDataAsync
    Inherits System.Windows.Forms.Form
    WithEvents m_objObserver As New ManagementOperationObserver()
    Dim m_blnProcess As Boolean = False

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents btnExecute As System.Windows.Forms.Button
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents txtQuery As System.Windows.Forms.TextBox
    Friend WithEvents lstResults As System.Windows.Forms.ListBox
    Friend WithEvents btnCancel As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.btnExecute = New System.Windows.Forms.Button()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.txtQuery = New System.Windows.Forms.TextBox()
        Me.lstResults = New System.Windows.Forms.ListBox()
        Me.btnCancel = New System.Windows.Forms.Button()
        Me.SuspendLayout()
        '
        'btnExecute
        '
        Me.btnExecute.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right)
        Me.btnExecute.Location = New System.Drawing.Point(568, 360)
        Me.btnExecute.Name = "btnExecute"
        Me.btnExecute.Size = New System.Drawing.Size(152, 23)
        Me.btnExecute.TabIndex = 0
        Me.btnExecute.Text = "Execute Query (Async)"
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(8, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(56, 23)
        Me.Label1.TabIndex = 1
        Me.Label1.Text = "Query:"
        '
        'txtQuery
        '
        Me.txtQuery.Anchor = ((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.txtQuery.Location = New System.Drawing.Point(56, 8)
        Me.txtQuery.Name = "txtQuery"
        Me.txtQuery.Size = New System.Drawing.Size(664, 22)
        Me.txtQuery.TabIndex = 2
        Me.txtQuery.Text = "SELECT * FROM Win32_NTLogEvent "
        '
        'lstResults
        '
        Me.lstResults.Anchor = (((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.lstResults.ItemHeight = 16
        Me.lstResults.Location = New System.Drawing.Point(8, 32)
        Me.lstResults.Name = "lstResults"
        Me.lstResults.Size = New System.Drawing.Size(712, 324)
        Me.lstResults.TabIndex = 3
        '
        'btnCancel
        '
        Me.btnCancel.Anchor = (System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left)
        Me.btnCancel.Location = New System.Drawing.Point(8, 360)
        Me.btnCancel.Name = "btnCancel"
        Me.btnCancel.Size = New System.Drawing.Size(88, 23)
        Me.btnCancel.TabIndex = 4
        Me.btnCancel.Text = "Cancel"
        '
        'ReadDataAsync
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(6, 15)
        Me.ClientSize = New System.Drawing.Size(728, 392)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.btnCancel, Me.lstResults, Me.txtQuery, Me.Label1, Me.btnExecute})
        Me.Name = "ReadDataAsync"
        Me.Text = "ReadDataAsync"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub btnExecute_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnExecute.Click
        ' This is where all the good stuff is!
        Try ' Errors in your WQL are common so we will watch for that.
            ' Define where to run our WQL Query

            ' Set the class level variable to say we are currently processing.
            m_blnProcess = True

            ' Define the query to be run Async.
            Dim objWMISearcher As ManagementObjectSearcher = _
                New ManagementObjectSearcher(Me.txtQuery.Text)
            Dim objWMIClass As ManagementBaseObject

            ' You can use this method below if you dont want to use WithEvents
            'AddHandler m_objObserver.ObjectReady, _
            '    AddressOf ReadDataAsync.ModifyUserNameAsyncComplete

            Me.lstResults.Items.Clear() ' Clear previous results
            ' Execute the query  results retrieved by the ObjectReady event
            objWMISearcher.Get(m_objObserver)
        Catch ex As Exception
            ' Opps we have an error
            MessageBox.Show("ERROR: " & ex.Message)
        End Try
    End Sub

    Private Sub m_objObserver_ObjectReady(ByVal sender As Object, _
            ByVal e As System.Management.ObjectReadyEventArgs) _
            Handles m_objObserver.ObjectReady

        ' Add the returned data to the listbox on the form.
        Me.lstResults.Items.Add(e.NewObject.ToString)

        ' This can lead to a tight loop as all the results come in.
        Application.DoEvents()

        ' Check if we should be continuing processing of the events
        If Not m_blnProcess Then
            ' Stop the processing of events by cancelling the operation
            CType(sender, ManagementOperationObserver).Cancel()
        End If
        ' Move the selected item to the last position so we can see it.
        Me.lstResults.SelectedIndex = Me.lstResults.Items.Count
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, _
            ByVal e As System.EventArgs) Handles btnCancel.Click
        ' Set the class level variable to False, this will be examined each time
        ' the ObjectReady event is fired, so we can stop processing at any time.
        m_blnProcess = False
    End Sub
End Class
