Option Strict On
Imports System.Management
Imports System.Management.Instrumentation

<Assembly: Instrumented("root\Samples")> 


' This class is self contained and is used
' to automatically install all the WMI Schema
' data into the CIM.
' You must however use the InstallUtil.exe
' for this class to run.
<System.ComponentModel.RunInstaller(True)> _
Public Class SalesInstaller
    Inherits DefaultManagementProjectInstaller

End Class

' This is an Event Class used to fire
' a custom event that will be exposed
' by WMI.
'<InstrumentationClass(InstrumentationType.Event)> _
Public Class NewUserEventHandler
    Inherits BaseEvent
    Public Username As String
End Class

' This is the main class which is used to log
' users onto the system.
Public Class LoggonUsers
    Inherits Instance
    Dim m_colUsers As New ArrayList()

    Sub New()
        ' This line registers the current instance with WMI, so its vital!
        ' Also it should be the LAST line when initialising your object.
        MyBase.Published = True
    End Sub

    Public Sub Logon(ByVal Username As String)
        m_colUsers.Add(New User(Username))
        Dim objNewUserEventHandler As New NewUserEventHandler()
        objNewUserEventHandler.Username = Username
        objNewUserEventHandler.Fire()
        'System.Management.Instrumentation.Instrumentation.Fire(objNewUserEventHandler)
    End Sub

    Public ReadOnly Property Count() As Integer
        Get
            Return m_colUsers.Count
        End Get
    End Property

    '<IgnoreMember()> _
    Public ReadOnly Property Items() As Object
        Get
            Return m_colUsers
        End Get
    End Property
End Class

' This class is only using Attributes to mark it as
' a WMI managed class. Allowing it to inherit from
' another class if required.
<InstrumentationClass(InstrumentationType.Instance)> _
Public Class User
    Private m_strUsername As String
    Private m_dtmLoggedInAt As DateTime

    Sub New()
        Me.New("") ' Supply default user of Blank
    End Sub

    Sub New(ByVal Username As String)
        m_dtmLoggedInAt = DateTime.Now()
        Me.Username = Username

        ' This line registers the current instance with WMI, so its vital!
        ' Also it should be the LAST line when initialising your object.
        ' Note: this uses a different technique to the LoggonUsers object.
        System.Management.Instrumentation.Instrumentation.Publish(Me)
    End Sub

    Public Property Username() As String
        Get
            Return m_strUsername
        End Get
        Set(ByVal Value As String)
            m_strUsername = Value
        End Set
    End Property

    ' This property is dynamic and will change depending on the 
    ' amount of time the user has been logged in.
    ReadOnly Property MinutesLoggedIn() As Long
        Get
            Return DateTime.Now.Subtract(m_dtmLoggedInAt).Minutes
        End Get
    End Property
End Class
